## intel-gmmlib 22.8.1

=== debian/changelog ===
intel-gmmlib (22.8.1-1ppa1~noble1) noble; urgency=medium

  * Bump to version 22.8.1

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 09 Sep 2025 09:50:16 +0800

intel-gmmlib (22.8.0-1ppa1~noble1) noble; urgency=medium

  * Bump to version 22.8.0

  *d/p: removed patches no longer needed
    -0001-Add-BMG-E-NEX1-and-NEX2-Device-ID.patch
    -0003-Add-new-BMG-Device-ID-234.patch

 -- Mustaffa, Mustamin B <mustamin.b.mustaffa@intel.com>  Fri, 22 Aug 2025 14:07:50 +0800

intel-gmmlib (22.7.1-1ppa1~noble2) noble; urgency=medium

  * debian/patches: Add new BMG Device ID (#234)
    - 0003-Add-new-BMG-Device-ID-234.patch

 -- Abd Razak, Muhammad Azizul Hazim <muhammad.azizul.hazim.abd.razak@intel.com>  Wed, 21 May 2025 17:00:35 +0800
