## intel-gmmlib 22.8.1+ds1

=== debian/changelog ===
intel-gmmlib (22.8.1+ds1-1) unstable; urgency=medium

  * New upstream version 22.8.1+ds1

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 28 Jul 2025 09:26:45 +0200
