=== debian/watch ===
version=4
opts="uversionmangle=s/.pre/~pre/,dversionmangle=s/@DEB_EXT@//,repacksuffix=+ds1" \
   https://github.com/intel/gmmlib/tags \
   (?:.*?/)intel-gmmlib@ANY_VERSION@\.tar\.gz
