## intel-gmmlib 22.8.2

=== debian/changelog ===
intel-gmmlib (22.8.2-1ppa1~noble2) noble; urgency=medium

  * debian/patches: Restructure for upstream tracking

 -- Neoh, Ying Lun <ying.lun.neoh@intel.com>  Thu, 30 Oct 2025 15:00:37 +0800

intel-gmmlib (22.8.2-1ppa1~noble1) noble; urgency=medium

  * Bump to version 22.8.2

 -- Mustamin Bin Mustaffa <mustamin.b.mustaffa@intel.com>  Tue, 07 Oct 2025 16:39:17 +0800
