=== debian/changelog ===
intel-gmmlib (22.8.2+ds1-1) unstable; urgency=medium

  * New upstream version 22.8.2+ds1

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 22 Sep 2025 22:13:20 +0200
