=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  debhelper-compat (= 13),
  cmake,
  libspdlog-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Homepage: https://github.com/intel/gmmlib
 Vcs-Browser: https://salsa.debian.org/multimedia-team/intel-gmmlib
 Vcs-Git: https://salsa.debian.org/multimedia-team/intel-gmmlib.git
@@ -45,12 +45,3 @@
  This library is only useful for Broadwell and newer CPUs.
  .
  This package includes files for development.
-
-Package: intel-gmmlib
-Architecture: amd64 i386 x32
-Multi-Arch: same
-Depends:
- libigdgmm12 (= ${binary:Version})
-Description: Intel Graphics Memory Management Library -- compatibility package
-  This package pulls in libigdgmm11 and is only present for compatibility
-  purposes.
