## intel-gmmlib 22.9.0+ds1

=== Source/GmmLib/CMakeLists.txt ===
--- 
+++ 
@@ -25,14 +25,14 @@
 
 # GmmLib Api Version used for so naming
 set(GMMLIB_API_MAJOR_VERSION 12)
-set(GMMLIB_API_MINOR_VERSION 8)
+set(GMMLIB_API_MINOR_VERSION 9)
 
 if(NOT DEFINED MAJOR_VERSION)
 	set(MAJOR_VERSION 12)
 endif()
 
 if(NOT DEFINED MINOR_VERSION)
-	set(MINOR_VERSION 8)
+	set(MINOR_VERSION 9)
 endif()
 
 if(NOT DEFINED PATCH_VERSION)
@@ -204,7 +204,8 @@
 	${BS_DIR_GMMLIB}/CachePolicy/GmmGen11CachePolicy.h
 	${BS_DIR_GMMLIB}/CachePolicy/GmmGen12CachePolicy.h
         ${BS_DIR_GMMLIB}/CachePolicy/GmmXe_LPGCachePolicy.h
-        ${BS_DIR_GMMLIB}/CachePolicy/GmmXe2_LPGCachePolicy.h	
+        ${BS_DIR_GMMLIB}/CachePolicy/GmmXe2_LPGCachePolicy.h
+	${BS_DIR_GMMLIB}/CachePolicy/GmmXe3P_XPCCachePolicy.h	
 	${BS_DIR_GMMLIB}/CachePolicy/GmmGen12dGPUCachePolicy.h
 	${BS_DIR_GMMLIB}/CachePolicy/GmmGen8CachePolicy.h
 	${BS_DIR_GMMLIB}/CachePolicy/GmmGen9CachePolicy.h
@@ -213,6 +214,7 @@
 	${BS_DIR_GMMLIB}/inc/External/Common/CachePolicy/GmmCachePolicyGen12.h
 	${BS_DIR_GMMLIB}/inc/External/Common/CachePolicy/GmmCachePolicyXe_LPG.h
         ${BS_DIR_GMMLIB}/inc/External/Common/CachePolicy/GmmCachePolicyXe2_LPG.h
+	${BS_DIR_GMMLIB}/inc/External/Common/CachePolicy/GmmCachePolicyXe3P_XPC.h	
 	${BS_DIR_GMMLIB}/inc/External/Common/CachePolicy/GmmCachePolicyGen12dGPU.h
 	${BS_DIR_GMMLIB}/inc/External/Common/CachePolicy/GmmCachePolicyGen8.h
 	${BS_DIR_GMMLIB}/inc/External/Common/CachePolicy/GmmCachePolicyGen9.h
@@ -278,6 +280,7 @@
   ${BS_DIR_GMMLIB}/CachePolicy/GmmGen12CachePolicy.cpp
   ${BS_DIR_GMMLIB}/CachePolicy/GmmXe_LPGCachePolicy.cpp
   ${BS_DIR_GMMLIB}/CachePolicy/GmmXe2_LPGCachePolicy.cpp
+  ${BS_DIR_GMMLIB}/CachePolicy/GmmXe3P_XPCCachePolicy.cpp
   ${BS_DIR_GMMLIB}/CachePolicy/GmmGen12dGPUCachePolicy.cpp
   ${BS_DIR_GMMLIB}/Platform/GmmGen11Platform.cpp
   ${BS_DIR_GMMLIB}/Platform/GmmGen12Platform.cpp
@@ -287,7 +290,3 @@
   ${BS_DIR_GMMLIB}/Platform/GmmPlatform.cpp
   ${BS_DIR_GMMLIB}/Resource/GmmResourceInfo.cpp
   ${BS_DIR_GMMLIB}/Resource/GmmResourceInfoCommon.cpp
-  ${BS_DIR_GMMLIB}/Resource/GmmResourceInfoCommonEx.cpp
-  ${BS_DIR_GMMLIB}/Resource/GmmRestrictions.cpp
-  ${BS_DIR_GMMLIB}/Resource/Linux/GmmResourceInfoLinCWrapper.cpp
-  ${BS_DIR_GMMLIB}/Texture/GmmGen7Texture.cpp
