=== debian/changelog ===
intel-gmmlib (22.9.0+ds1-1) unstable; urgency=medium

  * New upstream version 22.9.0+ds1

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 20 Dec 2025 10:33:31 +0100
